<template>
  <div class="flex flex-col">
    <div class="flex justify-center">
      <div class="text-xl text-white w-[40rem]">
        {{ question_str }}
      </div>
    </div>
    <div class="flex mt-4 justify-center items-center">
      <div class="inline-block">
        <a-input label="Coutry:" placeholder="country" :validators="letterNamesValidators" v-model="country" />
        <submit-button value="find" @click="execute" />
      </div>
      <sql-query-text>{{ sql_query }}</sql-query-text>
    </div>
    <div class="flex justify-center">
      <Masons />
    </div>

  </div>
</template>

<script>
import AInput from '@/components/AInput.vue';
import { letterNamesValidator } from '@/components/Validators.js'
import SubmitButton from '@/components/SubmitButton.vue';
import TableBase from '@/components/TableBase.vue';
import ComplexSqlQueries from '@/assets/ComplexQueries.json';
import SqlQueryText from '@/components/SqlQueryText.vue';
import Masons from '@/components/Masons.vue';
import { mapMutations } from 'vuex';
import { add_masons } from '@/components/helpers';
import axiosClient from '@/axiosClient';

export default {
  components: {
    AInput,
    SubmitButton,
    TableBase,
    SqlQueryText,
    Masons
  },
  data() {
    return {
      letterNamesValidators: [letterNamesValidator],
      question_str: ComplexSqlQueries[1].question,
      sql_query: ComplexSqlQueries[1].query,
      country: undefined,
    }
  },
  methods: {
    ...mapMutations(['clearMasons']),
    execute() {
      axiosClient.get('complex-query/2', { headers: { k: this.country } })
        .then((response) => {
          this.clearMasons()
          add_masons(response)
        })
    }
  },
  mounted() {
    this.clearMasons()
  }
}


</script>